//ObjektHinterZweitesLegen_201d.js
// 21.11.06 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//Dieses Script dient zum Positionieren des ersten ausgewhlten 
//Rahmens hinter den zweiten ausgewhlten Rahmen

// Prfen, ob zwei Rahmen ausgewhlt sind
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.");
	exit();
}

if (app.selection.length < 2) {
	alert ("Zwei Rahmen auswhlen\nund das Script nochmals starten.");
	exit();
}
else if (app.selection.length > 2) {
	alert ("Nur *zwei* Rahmen aufs Mal auswhlen.");
	exit();
}

// die Auswahl speichern
var curSel = app.selection;
var actSpread = app.activeWindow.activeSpread;

// die 'id' der beiden Objekte speichern
// das Element '0' ist immer jenes, welches zuletzt ausgewhlt worden ist ...
var id1 = curSel[0].id;
var id2 = curSel[1].id;

// die Seitenobjekte auflisten
var idList = actSpread.pageItems.everyItem().id;

// Variablen initialisieren
var nItems = idList.length;
var idTop = idList[0];
var topItem = actSpread.pageItems[0];
var idBot = idList[nItems-1];

// wenn das Objekt 'id1' das letzte der Liste 'idList' ist, kann man 
// das Objekt 'id2' ganz nach hinten senden (und umgekehrt)
if (id1 == idBot) {
	curSel[1].sendToBack();
}
else if (id2 == idBot) {
	curSel[0].sendToBack();
}

// wenn das Objekt 'id1' das erste der Liste 'idList' ist, und 'id2' 
// das zweite, dann muss man dieses ganz nach vorn holen
else {
	if (id1 == idTop) {
		if (id2 == idList[1]) {
			actSpread.pageItems[1].bringToFront();
		}
		// sonst muss man eine Schleife durch die Objekte machen, damit die z-Position 
		// des Rahmens gefunden werden kann
		else {
			for (i=0; i<nItems; i++) {
				if (idList[i] == id2) {
					var itPos = i;
					break;
				}
			}
			// dann erstellt man eine temporre Gruppierung von zweiten Seitenobjekt 
			// bis zum Rahmen, dessen Position man festgestellt hat. Diese Gruppe wird 
			// nach vorne geholt und die Gruppierung wird aufgelst
			try {
				var tmpGroup = actSpread.groups.add(actSpread.pageItems.itemByRange(1, itPos));
				tmpGroup.bringToFront();
				tmpGroup.ungroup();
			}
			catch (e) {
			}
		}
	}
	// nachstehend sind dieselben Operationen fr den Fall, dass der andere Rahmen ganz vorne ist
	else if (id2 == idTop) {
		if (id1 == idList[1]) {
			actSpread.pageItems[1].bringToFront();
		}
		else {
			for (i=0; i<nItems; i++) {
				if (idList[i] == id1) {
					var itPos = i;
					break;
				}
			}
			try {
				var tmpGroup = actSpread.groups.add(actSpread.pageItems.itemByRange(1, itPos));
				tmpGroup.bringToFront();
				tmpGroup.ungroup();
			}
			catch (e) {
			}
		}
	}
	// sonst muss man die Liste 'idList' durchgehen, um die Position der beiden Rahmen zu finden
	else {
		for (i=0; i<nItems; i++) {
			if (idList[i] == id1) {
				var pos1 = i;
				break;
			}
		}
		for (i=0; i<nItems; i++) {
			if (idList[i] == id2) {
				var pos2 = i;
				break;
			}
		}
		// wenn die Position 1 kleiner als die zweite ist
		if (pos1 < pos2) {
			// und wenn die Differenz grsser als 1 ist ...
			if (pos2 - pos1 > 1) {
				// ... aber das erste Objekt ist das zweite in der Schichtung, dann muss man 
				// eine temporre Gruppierung machen, diese in den Vordergrund holen, sowie 
				// das isoliert Objekt bevor die Grupperung aufgelst wird
				if (pos1 == 1) {
					var tmpGroup = actSpread.groups.add(actSpread.pageItems.itemByRange(2, pos2));
					tmpGroup.bringToFront();
					actSpread.pageItems[1].bringToFront();
					tmpGroup.ungroup();
				}
				else {
					var tmpGroup2 = actSpread.groups.add(actSpread.pageItems.itemByRange((pos1 + 1), pos2));
					var tmpGroup1 = actSpread.groups.add(actSpread.pageItems.itemByRange(0, (pos1 - 1)));
					tmpGroup2.bringToFront();
					tmpGroup1.bringToFront();
					tmpGroup1.ungroup();
					tmpGroup2.ungroup();
				}
			}
			// sonst sendet man den ersten Rahmen ganz nach hinten
			else {
				actSpread.pageItems.item(pos1).sendBackward();
			}
		}
		// wie oben, aber mit umgekehrten Positionen
		else {
			if (pos1 - pos2 > 1) {
				if (pos2 == 1) {
					var tmpGroup = actSpread.groups.add(actSpread.pageItems.itemByRange(2, pos1));
					tmpGroup.bringToFront();
					actSpread.pageItems[1].bringToFront();
					tmpGroup.ungroup();
				}
				else {
					var tmpGroup2 = actSpread.groups.add(actSpread.pageItems.itemByRange((pos2 + 1), pos1));
					var tmpGroup1 = actSpread.groups.add(actSpread.pageItems.itemByRange(0, (pos2 - 1)));
					tmpGroup2.bringToFront();
					tmpGroup1.bringToFront();
					tmpGroup1.ungroup();
					tmpGroup2.ungroup();
				}
			}
			else {
				actSpread.pageItems.item(pos2).sendBackward();
			}
		}
	}
}